var getSkipLabel = require('utility').getSkipLabel;


//
// Add the titles of the test cases to the list to get them loaded to the table view
//
exports.createData = function() {
    var acceptanceData = [
        // {title:'TIMOBXXXX', hasChild:true, level:"acceptance"}
        {
            title: 'TIMOB6684',
            hasChild: true,
            level: "acceptance"
        }, {
            title: 'TIMOB7187',
            hasChild: true,
            level: "acceptance"
        }, {
            title: 'TIMOB7673',
            hasChild: true,
            level: "acceptance"
        }, {
            title: 'TIMOB9214',
            hasChild: true,
            level: "acceptance"
        }, {
            title: 'TIMOB9663',
            hasChild: true,
            level: "acceptance"
        }, {
            title: 'TIMOB9878',
            hasChild: true,
            level: "acceptance"
        }, {
            title: 'TIMOB10214_a',
            hasChild: true,
            level: "acceptance"
        }, {
            title: 'TIMOB10214_b',
            hasChild: true,
            level: "acceptance"
        }, {
            title: 'TIMOB11537',
            hasChild: true,
            level: "acceptance"
        }, {
            title: 'TIMOB13339',
            hasChild: true,
            level: "acceptance"
        }, {
            title: 'TIMOB7624',
            hasChild: true,
            level: "acceptance"
        }, {
            title: 'TIMOB11690',
            hasChild: true,
            level: "acceptance"
        }, {
            title: 'TIMOB10419',
            hasChild: true,
            level: "acceptance"
        }, {
            title: 'TIMOB5881',
            hasChild: true,
            level: "acceptance"
        }, {
            title: 'TIMOB15770',
            hasChild: true,
            level: "acceptance"
        }
    ]

    return acceptanceData;
};


//
// TIMOB-XXXX
// JIRA Issue title
//
exports.TIMOBXXXX = function(_window) {

    if (!(Ti.Platform.osname == 'ipad' || Ti.Platform.osname == 'iphone')) { // effectively a list of supported platforms
        var label = getSkipLabel();
        _window.add(label);
        return _window;
    }
};


//
// TIMOB-7673
// Ti API: "replaceAt", "insertAt", and "getAt" functionality for view-like UI components
//

exports.TIMOB7673 = function(_window) {

    _window.layout = 'vertical'

    var optionsView = Ti.UI.createView({
        height: 50,
        backgroundColor: '#ccc'
    });

    var insertButton = Ti.UI.createButton({
        left: 0,
        width: 100,
        title: 'insertAt 2'
    });

    var replaceButton = Ti.UI.createButton({
        right: 0,
        width: 100,
        title: 'replaceAt 4'
    });

    optionsView.add(insertButton);
    optionsView.add(replaceButton);

    _window.add(optionsView);

    for (var i = 0; i < 10; i++) {
        _window.add(Ti.UI.createView({
            height: 30,
            backgroundColor: 'green',
            top: 5
        }));
    }

    var flag1 = 0;
    var flag2 = 0;
    insertButton.addEventListener('click', function() {
        _window.insertAt({
            view: Ti.UI.createLabel({
                top: 5,
                width: Ti.UI.FILL,
                height: 50,
                text: 'insertAt',
                backgroundColor: flag1++ % 2 ? 'blue' : 'red'
            }),
            position: 2
        });
    });
    replaceButton.addEventListener('click', function() {
        _window.replaceAt({
            view: Ti.UI.createLabel({
                top: 5,
                width: Ti.UI.FILL,
                height: 50,
                text: 'replaceAt',
                backgroundColor: flag2++ % 2 ? 'yellow' : 'orange'
            }),
            position: 4
        });
    });
    return _window;
};


//
// TIMOB-11690
// TiAPI: hideKeyboard method for view
//

exports.TIMOB11690 = function(_window) {
    _window.backgroundColor = '#ccc';

    var textField = Ti.UI.createTextField({
        borderStyle: Ti.UI.INPUT_BORDERSTYLE_ROUNDED,
        color: '#336699',
        width: 250,
        height: 60
    });
    _window.add(textField);

    _window.addEventListener('click', function(e) {
        if (e.source !== textField)
            _window.hideKeyboard();
    });
    return _window;
};



//
// TIMOB-7187: TI API: validRow property exists in iOS, but not Android
//
exports.TIMOB7187 = function(_window) {
    _window.backgroundColor = "blue";
    _window.addEventListener('open', function(e) {
        Ti.API.info('WIN OPENED');
        var db = Ti.Database.open('testdb');
        db.execute('DROP TABLE IF EXISTS welcome');
        db.execute("CREATE TABLE IF NOT EXISTS welcome (title TEXT)");
        db.execute("INSERT INTO welcome (title) VALUES (?)", 'one');
        db.execute("INSERT INTO welcome (title) VALUES (?)", 'two');
        db.close();
    });

    var tbtn = Ti.UI.createButton({
        title: 'Returns True',
        top: '5dp',
        height: '40dp'
    });
    var fbtn = Ti.UI.createButton({
        title: 'Returns False',
        top: '55dp'
    });

    tbtn.addEventListener('click', function(e) {
        var db = Ti.Database.open('testdb');
        var rows = db.execute("SELECT title FROM welcome where title='one'");
        Ti.API.info("ROW VALID property: " + rows.validRow);
        Ti.API.info("ROW VALID method: " + rows.isValidRow());
        rows.close();
        db.close();
    });

    fbtn.addEventListener('click', function(e) {
        var db = Ti.Database.open('testdb');
        var rows = db.execute("SELECT title FROM welcome where title='three'");
        Ti.API.info("ROW VALID property: " + rows.validRow);
        Ti.API.info("ROW VALID method: " + rows.isValidRow());
        rows.close();
        db.close();
    });
    _window.add(tbtn);
    _window.add(fbtn);
    return _window;

};

//
// TIMOB-6684: Move Object.prototype.extend to the "kroll" namespace
//
exports.TIMOB6684 = function(_window) {

    _window.backgroundColor = "red";

    var x = {};
    Ti.API.info("-------> value of extend for \"x\" is: " + x.extend);

    if (x.extend === undefined) {
        Ti.API.info("\"x\" is undefined");

    } else {
        Ti.API.info("\"x\" is not undefined");
    }
    return _window;
};
//
// TIMOB-13339
//Android: Add support for onUserLeaveHint for activities
//
exports.TIMOB13339 = function(_window) {

    if (!(Ti.Platform.osname == 'android')) { // effectively a list of supported platforms
        var label = getSkipLabel();
        _window.add(label);
        return _window;
    }

    _window.backgroundColor = 'red';
    _window.exitOnClose = true;
    _window.navBarHidden = true;

    _window.addEventListener('open', function() {
        _window.getActivity().addEventListener('userleavehint', function() {
            Ti.API.info("Activity USER_LEAVE_HINT!!!!");
        });
    });

    _window.addEventListener('click', function() {
        var secondWin = Ti.UI.createWindow({
            backgroundColor: 'blue',
            orientationModes: [Titanium.UI.PORTRAIT],
            navBarHidden: true
        });

        secondWin.open();
    });

    return _window;
};

//
// TIMOB-9214: Trace messages do not appear in Studio
//
exports.TIMOB9214 = function(_window) {
    Ti.API.trace("TRACE TRACE TRACE");
    Ti.API.info("INFO INFO INFO");
    Ti.API.debug("DEBUG DEBUG DEBUG");

    var label = Ti.UI.createLabel({
        text: 'check studio console'
    });

    _window.add(label);

    return _window;
};

//
// TIMOB-7624: Android: Ti.API - enable logging methods to accept either an array of strings or a string
//
exports.TIMOB7624 = function(_window) {
    var btn1 = Titanium.UI.createButton({
        color: '#A01',
        title: 'Logs',
        font: {
            fontSize: 20,
            fontFamily: 'Helvetica Neue'
        },
        textAlign: 'center',
        width: 'auto',
        top: 200
    });

    btn1.addEventListener('click', function() {
        Ti.API.info('yo', 'word');
        Ti.API.debug('durp');
        Ti.API.warn('foo', 'bar', 'baz');
        Ti.API.log('level', 'message', 'goes', 'here');
        Ti.API.info();
    })
    _window.add(btn1);


    return _window;
};
//
// TIMOB-9663
// iOS: Parity issue with 'NaN'
//
exports.TIMOB9663 = function(_window) {

    var a1 = NaN;
    var b1 = parseInt("X", 10);
    Ti.API.info("A1:" + a1);
    Ti.API.info("B1:" + b1);
    Ti.API.info(a1);
    Ti.API.info(b1);

    var y = {
        a2: NaN,
        b2: parseInt("X", 10)
    };
    Ti.API.info("A2:" + y.a2);
    Ti.API.info("B2:" + y.b2);
    Ti.API.info(y.a2);
    Ti.API.info(y.b2);
    return _window;
};

//

// TIMOB-9878: Facebook authorization has changed and login does not work anymore

//

exports.TIMOB9878 = function(_window) {
    facebook = require('facebook');

    facebook.appid = '495338853813822';
    facebook.permissions = ['publish_stream'];
    facebook.forceDialogAuth = true;
    facebook.addEventListener('login', function(e) {

        if (e.success) {
            alert('Logged in');
        }
    });

    facebook.addEventListener('logout', function(e) {

        alert('Logged out');

    });

    // Add the button.  Note that it doesn't need a click event listener.

    if (Titanium.Platform.name == 'android') {

        _window.add(facebook.createLoginButton({
            top: 50,
            style: 'wide'

        }));

    } else {

        _window.add(facebook.createLoginButton({

            top: 50,

            style: facebook.BUTTON_STYLE_WIDE

        }));

    }

    return _window;
};

// TIMOB-15770: Android: When Facebook autorize, App crashed on Android 4.4 kitkat



exports.TIMOB15770 = function(win) {
    var fb = require('facebook');
    fb.appid = '495338853813822';
    fb.permissions = ['publish_stream', 'read_stream'];
    // Permissions your app needs
    fb.forceDialogAuth = true;

    var but = Ti.UI.createButton({
        title: 'authorize',
        top: 50
    });

    but.addEventListener('click', function(e) {
        fb.addEventListener('login', function(e) {
            if (e.success) {
                alert('Logged In');
            } else if (e.error) {
                alert(e.error);
            } else if (e.cancelled) {
                alert("Canceled");
            }
        });
        fb.authorize();
    });

    var but1 = Ti.UI.createButton({
        title: 'Logout',
        top: 120
    });

    but1.addEventListener('click', function(e) {
        fb.addEventListener('logout', function(e) {
            alert('Logged out');

        });
        fb.logout();
    });

    win.add(but);
    win.add(but1);

    return win;
};


//
// TIMOB-10214_a: TiAPI: Expose broadcast receiver API
//
exports.TIMOB10214_a = function(_window) {

    _window.fullscreen = false;
    _window.backgroundColor = 'blue';

    if (Ti.Platform.osname == 'ipad' || Ti.Platform.osname == 'iphone') { // effectively a list of supported platforms
        var label = getSkipLabel();
        _window.add(label);
        return _window;
    }



    var bc = Ti.Android.createBroadcastReceiver({
        url: 'mybroadcast.js'
    });
    var register = Ti.UI.createButton({
        top: 10,
        title: 'register broadcast receiver'
    });

    var unregister = Ti.UI.createButton({
        title: 'unregister broadcast receiver'
    });

    register.addEventListener('click', function() {
        Ti.Android.registerBroadcastReceiver(bc, [Ti.Android.ACTION_AIRPLANE_MODE_CHANGED]);
        Ti.API.info('-------registered broadcast receiver');
    });

    unregister.addEventListener('click', function() {
        Ti.Android.unregisterBroadcastReceiver(bc);
        Ti.API.info('-------unregistered broadcast receiver');
    });

    _window.add(register);
    _window.add(unregister);

    return _window;
};



//
// TIMOB-10214_b: TiAPI: Expose broadcast receiver API
//
exports.TIMOB10214_b = function(_window) {

    _window.fullscreen = false;
    _window.backgroundColor = 'blue';

    if (Ti.Platform.osname == 'ipad' || Ti.Platform.osname == 'iphone') { // effectively a list of supported platforms
        var label = getSkipLabel();
        _window.add(label);
        return _window;
    }


    var bc = Ti.Android.createBroadcastReceiver({
        onReceived: function() {
            Titanium.API.info("---------------- Hello World!  I am a broadcast ");
        }
    });
    var register = Ti.UI.createButton({
        top: 10,
        title: 'register broadcast receiver'
    });

    var unregister = Ti.UI.createButton({
        title: 'unregister broadcast receiver'
    });

    register.addEventListener('click', function() {
        Ti.Android.registerBroadcastReceiver(bc, [Ti.Android.ACTION_AIRPLANE_MODE_CHANGED]);
        Ti.API.info('-------registered broadcast receiver');
    });

    unregister.addEventListener('click', function() {
        Ti.Android.unregisterBroadcastReceiver(bc);
        Ti.API.info('-------unregistered broadcast receiver');
    });

    _window.add(register);
    _window.add(unregister);

    return _window;
};



//
// TIMOB-11537: iOS: API.timestamp results in runtime error TiUtils exceptionMessage unrecognized selector sent to class 0x4f4848
//
exports.TIMOB11537 = function(_window) {
    if (!(Ti.Platform.osname == 'ipad' || Ti.Platform.osname == 'iphone')) { // effectively a list of supported platforms
        var label = getSkipLabel();
        _window.add(label);
        return _window;
    }
    _window.backgroundColor = "white";
    Titanium.API.timestamp('Titanium.API.timestamp'); //this should print the timestamp in console
    var label = Ti.UI.createLabel({
        text: 'Check Console'
    });
    _window.add(label);
    return _window;
};



//
// TIMOB-10419: Android: Add API for supporting the Android Proximity Sensor functions
//
exports.TIMOB10419 = function(win) {
    var win = Titanium.UI.createWindow({
        backgroundColor: '#fff'
    });

    Ti.App.proximityDetection = true;

    var label = Ti.UI.createLabel({
        width: Ti.UI.SIZE,
        color: 'black'
    });

    win.add(label);

    Ti.App.addEventListener('proximity', function(e) {
        Ti.API.info("Proximity State = " + e.state);
        label.text = "Proximity State is : " + e.state;
        Ti.API.info("Proximity State = " + Ti.App.proximityState);
    });

    return win;
};


// TIMOB-5881: Ti API: DB result set: fieldCount is a property on Android, function on iPhone
//

exports.TIMOB5881 = function(win) {

    var db = Titanium.Database.open('mydb');
    db.execute('CREATE TABLE IF NOT EXISTS DATABASETEST (ID INTEGER, NAME TEXT)');
    db.execute('INSERT INTO DATABASETEST (ID, NAME ) VALUES(?,?)', 1, 'Name 1');
    db.execute('INSERT INTO DATABASETEST (ID, NAME ) VALUES(?,?)', 2, 'Name 2');
    db.execute('INSERT INTO DATABASETEST (ID, NAME ) VALUES(?,?)', 3, 'Name 3');
    db.execute('INSERT INTO DATABASETEST (ID, NAME ) VALUES(?,?)', 4, 'Name 4');

    var rows = db.execute('SELECT * FROM DATABASETEST');

    Ti.API.info('Field count: ' + rows.fieldCount);
    rows.close();
    db.close();

    return win;
};